#
# p7 - automated file reception utility
# Version 0.5 (Oct/13/02). Written by Alexandru Ciobanu <sasha_c@softhome.net>
# 
# Distribuited under the terms of GNU GPL
#
# Enjoy... :^)


BEGIN {  
    VERSION = "p7 v0.5"
    EXTRACT  = extr
    REL_PATH = rel_path
    sender_email = subject = date = att_file_name = ""
    attachement = email = files = archs = errors = 0
    boundary = "whatever :)"
    ulog((strftime("[%b/%d/%y  %R]",systime()) " BEGIN FETCH SESSION"))
    init_archs()
    log_br = "=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-==-=-=-=-=-"
}


#==============================================================
# reply to the sender
# h_type == 0 => with files       (use file ./conf/ok.reply)
# h_type == 1 => no files         (use file ./conf/no_att.reply)
# h_type == 2 => error in files   (use file ./conf/err.reply)
#==============================================================
function reply_header(h_type)
{		
    if (h_type==0) {
	r_file = (REL_PATH "/conf/ok.reply")
	r_cmd = "mail -s \x22Re: [OK] " subject "\x22 " sender_email
    }
    if (h_type==1) {
	r_file = (REL_PATH "/conf/no_att.reply")
	r_cmd = "mail -s \x22Re: [NOF] " subject "\x22 " sender_email
    }
    if (h_type==2) {
	r_file = (REL_PATH "/conf/err.reply")
	r_cmd = "mail -s \x22Re: [ERR] " subject "\x22 " sender_email
    }
	    
    if (h_type == 0 || h_type == 1 || h_type == 2) {
	while((getline < r_file)>0 && $1 !~ "Date:") {
	    print $0 | r_cmd
	}
	if ($1 ~ "Date:") {
	    print ($1 " " strftime("%b/%d/%y  %R",systime())) | r_cmd
   	    while((getline < r_file)>0) {
		print $0 | r_cmd
	    }	    	    
	}
	print ("\n" log_br "\n   Date:        " date "\n   From:        " sender_email"\n   Subject:     " subject "\n   Files:       " files "\n" log_br "\n") | r_cmd
	
	if (h_type == 1) {
	    print "\nEND OF MESSAGE.\n\n"VERSION | r_cmd
	    close(r_cmd)
	}
    }
    close(r_file)    
}


#==============================================================
# appends 'what' to the log file.
#==============================================================
function ulog(what)
{
    print what >> (REL_PATH "/loggy")
}


#==============================================================
# Initializes the commands for extracting, viewing and testing the archives 
# Reads the file './conf/archives' 
#==============================================================
function init_archs()
{
    fi = 1
    err_msg_arch = "ERROR: Malformed archives file - './conf/archives' !"
    a_ = 0
    while ((getline < (REL_PATH"/conf/archives"))>0) {
	if (index($0,"#")!=1) {	   	 
		
	    ## "A" line
	    if (index($0,"A")==1) {
		for (i=2; i<=NF; i++)
		    A[++archs] = $i
		a_ = 1
	    }
	    
	    ## "L" line
	    if (index($0,"L")==1) {
		if (a_)	{
		    tmp = ""
		    for (i=2; i<=NF; i++)
			tmp = tmp " " $i
		    tmp = substr(tmp,2)
		    for (i=fi; i<=archs; i++)
			L[A[i]] = tmp
		} else {
		    print err_msg_arch
		    ulog(("\n  " err_msg_arch "\n  EXITING...\n"))		    
		    exit
		}
		
	    }
	    
	    ## "E" line
	    if (index($0,"E")==1) {
		if (a_) {
		    tmp = ""
		    for (i=2; i<=NF; i++)
			tmp = tmp " " $i
		    tmp = substr(tmp,2)
		    for (i=fi; i<=archs; i++)
			E[A[i]] = tmp		    
		} else {
		    print err_msg_arch
		    ulog(("\n  " err_msg_arch "\n  EXITING...\n"))
		    exit
		}
	    }
	    
	    ## "T" line
	    if (index($0,"T")==1) {
		if (a_) {
		    tmp = ""
		    for (i=2; i<=NF; i++)
			tmp = tmp " " $i
		    tmp = substr(tmp,2)
		    for (i=fi; i<=archs; i++)
			T[A[i]] = tmp
		    fi = archs + 1
		    a_ = 0
		} else {
		    print err_msg_arch
		    ulog(("\n  " err_msg_arch "\n  EXITING...\n"))
		    exit
		}
	    }	    	    	
	} 
    } 
}

/^Date:/ {
    date = ""
    for (i=2; i<=NF; i++) date = date $i " "
    email = 1
}
 
/^From:/ {
    if (index($NF,"<") != 0) 
        sender_email = substr($NF,2,length($NF)-2)
    else
        sender_email = $NF	
    email = 1
}
    
/^Subject:/ {
    subject = ""
    for (i=2; i<=NF; i++) subject = subject $i " "
    email = 1
}

#==============================================================
# extracts value from 'tag=VALUE' and 'tag="VALUE"' expressions.
# parameter 	tag
# returns   	VALUE
#==============================================================
function get_tag_value(tag)
{
	do {
	    i = j = 0
	    do {
		i++
		j = index(tolower($i),tolower(tag)) 	
	    } while (i<=NF && j == 0) 
	    			    
	    if (j == 0) 
		getline				
	} while(j==0 && length($0)!=0)
	
	if (index($i,"\x22")) {
	    rtn = ""
	    for (j=i; j<=NF; j++)
		rtn = rtn " " $j
	    rtn = substr(rtn, length(tag)+3, length(rtn) - length(tag) -3) 
	    return rtn
	} else 
	    return (substr($(i),length(tag)+1,length($(i))-length(tag)))
}

/^Content-Type:/ || /^Content-type:/ {	
    if (attachement == 0 && email)  {
	if (index(tolower($2),"multipart/mixed")) {	
	    boundary = "--" get_tag_value("boundary=")
	    if (length(boundary)) 
		attachement = 1		    
	    next
	} else {
	    ulog("")
	    ulog(log_br)
	    ulog(("   Date:\t" date))
	    ulog(("   From:\t" sender_email))
	    ulog(("   Subject:\t" subject))
	    ulog(("   Files:\tNONE" ))
	    ulog(log_br)
	    ulog("")
	    reply_header(1)	    
	    email = 0	    	    	    
	}
    }

    if (attachement) {	
	att_file_name = get_tag_value("name=")
	if (att_file_name) {
	    
	    # check if the file is not already in list
	    k = 0
	    do {
		k++
	    } while((files_a[k] != att_file_name) && (k <= files))
	    
	    if (k > files) {
		files_a[++files] = att_file_name				
    		cmd  = "if [ ! -d " REL_PATH "/files/" sender_email " ]; \nthen mkdir \x22" REL_PATH "/files/" sender_email "\x22 ;\nfi"
		system(cmd)
                
                # find "encoding type"
		do {
		    k=0
		    for (l=1; l<=NF && k==0; l++) 
			k = index($l,"Content-Transfer-Encoding:");
		    if (!k) 
			getline
		} while(k==0 && length($0)!=0)
	    
		if (k)	
		    cte = $2
		else
		    cte = " "    
		    
		if (tolower(cte) !~ "base64") {
		    getline					   
		    place = REL_PATH "/files/" sender_email "/" att_file_name
    		    while ($0 !~ boundary && $0 !~ (boundary "--")) {		    
			print $0 > place
			getline
		    }	
		} else {
		
		    do {
			getline
		    } while (length($0)!=0)
		    getline
		    
		    # solve overwriting here
   		    xcmd = "[[ -e \x22" REL_PATH "/files/" sender_email "/" att_file_name "\x22 ]];"
		    fes  = system(xcmd)			
		    while (!fes) {
		        att_file_name = "_" att_file_name
		        xcmd = "[[ -e \x22" REL_PATH "/files/" sender_email "/" att_file_name "\x22 ]];"
		        fes  = system(xcmd)
		    }
		    files_a[files] = att_file_name
		    cmd = "mimencode -u -o \x22" REL_PATH "/files/" sender_email "/" att_file_name "\x22"
		    while (length($0)>0 && $0 !~ boundary && $0 !~ (boundary "--")) {
		        print $0 | cmd
		        getline
		    }
		    close(cmd)
		}		
	    } else {
		do {
		    getline
		} while ($0 !~ boundary)
		next
	    }
    	}	
    }    
}

#
# logging and replying takes place here.
#
$0 ~ (boundary "--") {

    system(("> " REL_PATH "/.tmp"))
        
    # Updating the log
    ulog("")
    ulog(log_br)
    ulog(("   Date:\t" date))
    ulog(("   From:\t" sender_email))
    ulog(("   Subject:\t" subject))
    ulog(("   Files:\t" files "\n"))    
    
    for (i=1; i<=files; i++) {
	ulog(("\t"(i ".") " " files_a[i]))	
	print (""(i ".") " " files_a[i]) >> (REL_PATH "/.tmp")
	
	u = ""
	for (j=1; j<=length(files_a[i])+3; j++)
	    u = u "="
	ulog(("\t" u))
	print u >> (REL_PATH "/.tmp")
	    
	j = 0
	do {
	    k = index(files_a[i],A[++j])	        
	} while( !(k && length(files_a[i]) == k + length(A[j])-1) && j <= archs)
	if (j<archs) {
	    q = index(T[A[j]],"%f")	    	    	    
	    if (q)
		tcmd  = substr(T[A[j]],1,q-1) " \x22" REL_PATH "/files/" sender_email "/" files_a[i] "\x22" substr(T[A[j]],q+2) " &>/dev/null"
	    else 
		tcmd  = T[A[j]] " &>/dev/null"
	    l_err = system(tcmd)
	    if (l_err == 0) {
		ulog("\t   LISTING OF ARCHIVE CONTENT FOLLOWS:")
		print "   LISTING OF ARCHIVE CONTENT FOLLOWS:" >> (REL_PATH "/.tmp")
	        q = index(L[A[j]],"%f")	    	    	    
		lcmd = substr(L[A[j]],1,q-1) " \x22" REL_PATH "/files/" sender_email "/" files_a[i] "\x22 " substr(L[A[j]],q+2)	   			    		
		while ((lcmd | getline)>0) {
		    ulog(("\t   " $0))
		    print ("   " $0) >>  (REL_PATH "/.tmp")
		}
		close(lcmd)
		if (EXTRACT) {
		    fsn = substr(files_a[i],1,k-1)
		    system(("mkdir -p \x22" REL_PATH "/files/" sender_email "/" fsn "\x22"))
		    p = index(E[A[j]],"%f")
		    ecmd = "cd \x22" REL_PATH "/files/" sender_email "/" fsn "\x22 ; " substr(E[A[j]],1,p-1) "\x22../" files_a[i] "\x22 " substr(E[A[j]],p+2) " 1>/dev/null"
		    system(ecmd)
		    ulog(("\n\t   EXTRACTED TO: ./files/" sender_email "/" fsn "/\n"))
		    close (ecmd)	    		
		}	    			
	    } else {
		errors = 1
		ulog("\t   ERROR: CORRUPTED ARCHIVE FILE!")
		print "   ERROR: CORRUPTED ARCHIVE FILE !" >> (REL_PATH "/.tmp")
		system(("rm \x22" REL_PATH "/files/" sender_email "/" files_a[i] "\x22"))
		ulog("\t   REMOVED.")
		print "   REMOVED" >> (REL_PATH "/.tmp")
	    }
	}	
	ulog("")
	print "" >> (REL_PATH "/.tmp")
    }
    if (files>1)
	c = "files"
    else 
	c = "file"	
    ulog(("TOTAL: " files " " c))
    ulog(log_br)
    ulog("")
    print ("END OF MESSAGE.\n\n" VERSION) >> (REL_PATH "/.tmp")
    
    if (errors) {
	reply_header(2)
    } else {
	reply_header(0)
    }
    tcmd="cat " REL_PATH "/.tmp"
    while ((tcmd | getline)>0) {
        print $0 | r_cmd
    }
    close(r_cmd)	    	    
    close(tcmd)
    attachement = email = files = errors = 0        
}

END {
    # delete arrays (nonobvious but portable manner)
    split("",files_a)  
    split("",A)
    split("",L)
    split("",E)
    ulog((strftime("[%b/%d/%y  %R]", systime()) " END FETCH SESSION\n\n"))
}